/*************************************************************************
MGLApp.h

Clip Earth Demo. Demo for "User Clip Planes" section

Author   :   Andrei Gradinari
Based on Dave Astle's application template

Written for More OpenGL Game Programming
August, 2005
*************************************************************************/

#ifndef MGLAPP_H_INCLUDED
#define MGLAPP_H_INCLUDED

#ifdef WIN32
  #define WIN32_LEAN_AND_MEAN
  #define WIN32_EXTRA_LEAN
  #include <windows.h>
#endif

#include "glee.h"
#include <gl/glu.h>

#include "MGLTargaImage.h"
#include "MGLTimer.h"
#include "MGLTypes.h"
#include "MGLVector.h"
#include "MGLUtil.h"
#include "prim.h"

// values used to set up the window and rendering context
const char MGL_APP_NAME[]	= "MOGLGP - Chapter 1 - User Clip Planes Demo";

const int MGL_WINDOW_WIDTH = 800;
const int MGL_WINDOW_HEIGHT = 600;

const int MGL_COLOR_BITS = 32;
const int MGL_DEPTH_BITS = 24;
const int MGL_STENCIL_BITS = 8;

const bool MGL_FORCE_FULLSCREEN = false;

class MGLApp
{
public:
	MGLApp();
	virtual ~MGLApp();

	bool Init();
	bool Shutdown();
	void SetupProjection( int width, int height );
	void Update( float dt );
	void Render();

private:
	float m_dElapTime;
	GLuint m_iEarthTexture;

	int m_nWindowWidth, m_nWindowHeight;
	Primitive *m_pEarth[3];
};

#endif // MGLAPP_H_INCLUDED