#ifndef CSIMPCAMERA_H_INCLUDED
#define CSIMPCAMERA_H_INCLUDED

#include "MGLVector.h"


const float PITCH_MAX = (PI/2 - 0.1f);

class CSimpCamera
{
public:
  CSimpCamera(float posx, float posy, float posz, float yaw, float pitch);
  CSimpCamera();

  virtual ~CSimpCamera() {}

  void SetPosition(float posx, float posy, float posz) { m_pos.Set(posx, posy, posz); }
  MGL::Vector3 GetPosition() { return m_pos; }

  void YawAndPitch(float yaw, float pitch);

  void SetView();

protected:
  MGL::Vector3 m_pos;
  MGL::Vector3 m_lookat;
  MGL::Vector3 m_up;
  float m_rotX;
  float m_rotY;
};


#endif // CSIMPCAMERA_H_INCLUDED