#ifdef WIN32
	#define WIN32_LEAN_AND_MEAN
	#define WIN32_EXTRA_LEAN
	#include <windows.h>
#endif

#include <cmath>
#include <fstream>
#include <string>
#include "glee.h"
#include "LoadProgram.h"

GLuint LoadProgram(GLenum target, std::string filename)
{
	//Open the program file
	std::ifstream programFile(filename.c_str());
	if(!programFile)
		return 0;

	//Read the file
	std::string programLine, programText;

	while(std::getline(programFile, programLine))
		programText += programLine + '\n';

	//Generate a program index
	unsigned int index;
	glGenProgramsARB(1, &index);
	if(index == 0)
		return 0;

	//Initialise the program
	glBindProgramARB(target, index);
	glProgramStringARB(	target, GL_PROGRAM_FORMAT_ASCII_ARB,
						static_cast<GLsizei>(programText.length()), programText.c_str());

	return index;
}