/*************************************************************************
MGLApp.h

Main application class.

Author   :   Dave Astle

Written for More OpenGL Game Programming
*************************************************************************/

#ifndef MGLAPP_H_INCLUDED
#define MGLAPP_H_INCLUDED

#ifdef WIN32
  #define WIN32_LEAN_AND_MEAN
  #define WIN32_EXTRA_LEAN
  #include <windows.h>
#endif

#include "glee.h"
#include <GL/glu.h>

// values used to set up the window and rendering context
const char MGL_APP_NAME[]	= "MOGLGP - Chapter 5 - Anisotropic Road";

const int MGL_WINDOW_WIDTH = 1024;
const int MGL_WINDOW_HEIGHT = 768;

const int MGL_COLOR_BITS = 32;
const int MGL_DEPTH_BITS = 24;
const int MGL_STENCIL_BITS = 0;

const bool MGL_FORCE_FULLSCREEN = false;


class MGLApp
{
public:
	MGLApp();
	virtual ~MGLApp();

	bool Init();
	bool Shutdown();
	void SetupProjection( int width, int height );
	void Update( double dt );
	void Render();

  void ToggleAnisotropy();

private:
  GLuint m_textures[2];
  GLfloat m_maxAnisotropy;
  GLboolean m_useAnisotropy;
  GLdouble m_translateT;
};

#endif // MGLAPP_H_INCLUDED