#ifndef IBL_CAMERA_H
#define IBL_CAMERA_H

#include "glee.h"
#include <gl/glu.h>

namespace ibl
{
	// A very simple camera class that orbits around the origin and zooms in and out.
	class Camera
	{
	private:	
		float mAngle[2];
		float mZoom;

	public:
		Camera()
		{
			mAngle[0] = -10;
			mAngle[1] = -20;
			mZoom = 100;
		}

		void rotate( float dx, float dy )
		{
			mAngle[0] += dx;
			mAngle[1] += dy;
		}

		void zoom( float dz )
		{
			mZoom += dz;
		}

		// sets the OpenGL matrix to view from this camera
		void setup()
		{
			glTranslatef(0,0,-mZoom);
			glRotatef(mAngle[0],1,0,0);
			glRotatef(mAngle[1],0,1,0);	
		}

		// sets the OpenGL matrix to only contain the rotation component
		// of this camera's view
		void setupRotation()
		{
			glRotatef(mAngle[0],1,0,0);
			glRotatef(mAngle[1],0,1,0);
		}

		// sets the OpenGL matrix to only contain the inverse of the
		// rotation component of this camera's view
		void setupInverseRotation()
		{
			glRotatef(-mAngle[1],0,1,0);			
			glRotatef(-mAngle[0],1,0,0);
		}
	};
}

#endif
