#ifndef IBL_CUBEMAP_H
#define IBL_CUBEMAP_H

#include "glee.h"
#include <gl/glu.h>
#include <string>

namespace ibl
{
	class Cubemap
	{
	private:
		// defines which texture unit this cubemap is bound to (GL_TEXTURE0, GL_TEXTURE1, etc)
		GLuint mTextureUnit;

		// OpenGL texture ID
		GLuint mCubemapID;

		// load a .pfm file
		bool loadPFM( const std::string & file );

		//load a .tga file
		bool loadLDR( const std::string & file );

	public:
		Cubemap();
		
		~Cubemap();

		void setTextureUnit( GLuint texUnit );

		// load cubemap from a .hdr or .tga vertical cross file
		bool load( const std::string & file );

		// enable and bind the appropriate stuff
		void bind()const;

		// disable the appropriate stuff
		void unbind()const;
	};
}

#endif
