#ifndef IBL_ENDIANNESS_H
#define IBL_ENDIANNESS_H

// define what endian the processor is
#ifdef _WIN32
#define IBL_LITTLE_ENDIAN
#elif __APPLE__
#define IBL_BIG_ENDIAN
#endif

namespace ibl
{
	template <class T> void flipEndian( T & data )
	{
		char * bytes = (char *)(&data);
        for( int i = 0; i<sizeof( T )/2; ++i )
		{
			int j = sizeof(T)-i-1;
			//swap
			bytes[i]^=bytes[j];
			bytes[j]^=bytes[i];
			bytes[i]^=bytes[j];
		}
	}
}

#endif
