#ifndef IBL_ENVIRONMENT_H
#define IBL_ENVIRONMENT_H

#include "Cubemap.h"

namespace ibl
{
	// structure that defines a lighting environment
	struct Environment
	{
		// rotation of the environment around the y axis, a neat 
		// demonstration of the effects of image based lighting
		float mRotation;

		// diffuse irradiance environment map
		Cubemap mDiffIrrMap;

		// reflection environment map
		Cubemap mReflectionMap;

		Environment() : mRotation( 0 )
		{
		}

		void bind()const
		{
			mDiffIrrMap.bind();
			mReflectionMap.bind();
		}

		void unbind()const
		{
			mDiffIrrMap.unbind();
			mReflectionMap.unbind();
		}
};

}

#endif
