#ifndef IBL_MESH_H
#define IBL_MESH_H

#include "glee.h"
#include <gl/glu.h>
#include <string>

namespace ibl
{
	// A class that encapsulates a set of triangles loaded from file
	// that can be rendered using vertex arrays.
	class Mesh
	{
	private:
		// array of 3-component vertex data
		float * mVertexBuffer;
		// array of 3-component normal data
		float * mNormalBuffer;
		// array of 2-component texture coordinate data
		float * mTexCoordBuffer;
		// number of vertices in this model
		size_t mVertexCount;

	public:
		Mesh();
		~Mesh();
		// loads mesh from a file, deleting pre-existing data
		void load( const std::string & file );
		// draw mesh
		void draw()const;
	};
}

#endif
