#ifndef IBL_MODEL_H
#define IBL_MODEL_H

#include "Mesh.h"
#include "Texture.h"

namespace ibl
{
	// structure that defines a textured model
	struct Model
	{
		Mesh * mMesh;
		Texture mTexture;

		void draw()const
		{
			if( mMesh )
			{
				mTexture.bind();				
				mMesh->draw();
				mTexture.unbind();				
			}
		}

		void destroy()
		{
			if( mMesh ) delete mMesh;
			mMesh = 0;
		}
	};
}

#endif
