#ifndef IBL_SHADER_H
#define IBL_SHADER_H

#include "glee.h"
#include <gl/glu.h>
#include <string>

namespace ibl
{
	class Shader
	{
	private:
		// GL_VERTEX_PROGRAM_ARB or GL_FRAGMENT_PROGRAM_ARB
		GLenum mType;
		
		// OpenGL shader ID
		GLuint mProgramID;
		
		// path to the shader on disk
		std::string mProgramPath;

		// the shader code itself
		std::string mProgramString;

	public:
		Shader();

		Shader( const Shader & src );

		~Shader();

		// load a shader from a .vp or .fp file
		void load( const std::string & file );
		
		// enable and bind the appropriate stuff
        void bind()const;

		// disable the appropriate stuff
		void unbind()const;
	};
}

#endif
