#ifndef IBL_TEXTURE_H
#define IBL_TEXTURE_H

#include "glee.h"
#include <gl/glu.h>
#include <string>

namespace ibl
{
	class Texture
	{
	private:
		// defines which texture unit this texture is bound to (GL_TEXTURE0, GL_TEXTURE1, etc)
		GLuint mTextureUnit;

		// OpenGL texture ID
		GLuint mTextureID;

		// load a portable float map
		bool loadPFM( const std::string & file );

		// load a .tga file
		bool loadLDR( const std::string & file );

	public:
		Texture();

		~Texture();

		void setTextureUnit( GLuint texUnit );

		// load texture from a .hdr or .tga file
		bool load( const std::string & file );

		// enable and bind the appropriate stuff
		void bind()const;

		// disable the appropriate stuff
		void unbind()const;
	};
}

#endif
