/* ==========================================================================

     File    edge.vsh
     Author  Josh Petrie (jpetrie@mac.com)
     
             This file is part of a example program written
             for the book "More OpenGL Game Programming."

   ========================================================================== */

varying vec2  texcc;
varying vec2  texcd;

void main(void)
{
  // Bring input data to view space.
vec4  viewVtx   = gl_ModelViewMatrix * gl_Vertex;
vec3  viewNrm   = gl_NormalMatrix * gl_Normal;
vec4  viewLight = gl_ModelViewMatrix * gl_LightSource[0].position;
  
  // Compute a vector from the vertex to the light.
vec3  lightDir = vec3(viewLight.xyz) - vec3(viewVtx.xyz);

  // Compute illumination method factor and store it in a texcoord.
  // For this example we will use simple diffuse lighting.
  texcc.x = max(0.0,dot(viewNrm,normalize(lightDir)));
  texcc.y = 0.0;
  
  texcd.x = gl_MultiTexCoord0.x;
  texcd.y = gl_MultiTexCoord0.y;
  
  // Bring view space position to clip space for output.
  gl_Position = gl_ProjectionMatrix * viewVtx;
}
