/*************************************************************************
MGLMath.h

Common math-related functions and constants.

Author   :   Dave Astle

Written for More OpenGL Game Programming
*************************************************************************/
#ifndef MGLMATH_H_INCLUDED
#define MGLMATH_H_INCLUDED

#define DEG2RAD(a)	(PI/180*(a))
#define RAD2DEG(a)	(180/PI*(a))
#define PI		(3.14159265359f)

// returns a number ranging from -1.0 to 1.0
#define FRAND   (((float)rand()-(float)rand())/RAND_MAX)

#define CLAMP(x, min, max)  x = (x<min  ? min : x<max ? x : max);

#define SQUARE(x)  (x)*(x)


#endif // MGLMATH_H_INCLUDED