/* ==========================================================================

     File    EdgeMesh.h
     Author  Josh Petrie (jpetrie@mac.com)
     
             This file is part of a example program written
             for the book "More OpenGL Game Programming."

   ========================================================================== */

/*                                                                      guard
----------------------------------------------------------------------------- */

#ifndef EDGEMESH_H_
#define EDGEMESH_H_


/*                                                                   includes
----------------------------------------------------------------------------- */

#include "GLee.h"

#include "MD2Model.h"

#include <set>
#include <utility>
#include <vector>


/*                                                                    structs
----------------------------------------------------------------------------- */

/*  _________________________________________________________________________ */
struct EdgeInfo
//! Encapsulates information about a single edge.
{ 
  int  v0;  //!< Index of vertex 0.
  int  v1;  //!< Index of vertex 1.
  int  v2;  //!< Index of vertex 2.
  int  v3;  //!< Index of vertex 3.
  
  int  a;  //!< Index of face A, which is (v0,v1,v2).
  int  b;  //!< Index of face B, which is (v1,v0,v3).
  
  int    i;  //!< Index of edge quad vertex.
};


/*                                                                   typedefs
----------------------------------------------------------------------------- */

// edge mesh
typedef std::vector< EdgeInfo >  EdgeMesh;


/*                                                                 prototypes
----------------------------------------------------------------------------- */

// building
EdgeMesh BuildEdgeMesh(const MD2Model &source);


#endif  /* EDGEMESH_H_ */