uniform samplerCube tex_unit_0;

varying vec3 nrml, light, eye;

//#define LIGHT gl_LightSource[0]
void main()
{
	vec3 L = normalize(light), E = normalize(eye);
	vec3 H = normalize(L + E);
	vec3 N = normalize(nrml);
	
	bool lit = light.z > 0.0;
	vec4 cubemap_color = textureCube(tex_unit_0, gl_TexCoord[0].xyz);
	
	vec2 intens = vec2( 0.4 * dot(N, L), pow(dot(N, H), 25.0) );
	intens = float(lit) * max(vec2(0,0), intens);
	
	//gl_FragColor = vec4( cubemap_color);
	
	gl_FragColor = vec4(vec3(intens[0] + intens[1]) // CUBEMAP + SPECULAR
					+ vec3(0.1) // AMBIENT
					
					,1.0);
}
