uniform sampler2D tex_unit_0;

varying vec3 nrml, light, eye;

#define LIGHT gl_LightSource[0]
void main()
{
	vec3 L = normalize(light), E = normalize(eye);
	vec3 H = normalize(L + E);
	vec3 N = normalize(nrml);
	
	vec4 diffuse = texture2D(tex_unit_0, gl_TexCoord[0].xy);
	bool lit = light.z > 0.0;
	
	float intens = 0.6*pow(dot(N, H), 25.0);
	intens = float(lit) * max(0.0, intens);
	
	gl_FragColor = vec4(vec3(intens) // SPECULAR
						,1.0);
}
