/// GL_TEXTURE_MATRIX_1 - light spot ModelViewProjectionMatrix

varying vec3 light, eye, nrml;

void main()
{
	gl_Position = gl_ModelViewMatrix * gl_Vertex;
    gl_TexCoord[0] = gl_MultiTexCoord0;	// diffuse/normal map coord
	
	// normal to eye space
	nrml = normalize(gl_NormalMatrix * gl_Normal);
	// vector to eye
	eye = -gl_Position.xyz;
	// vector to light
	light = gl_LightSource[0].position.xyz - 
		gl_Position.xyz * gl_LightSource[0].position.w;
	// here I multiply by gl_LightSource[0].position.w because 
	// when we deal with directional light(w=0) vertex position doesn't
	// affect v_to_light direction
	
	gl_Position.xyz += 0.2*nrml; // extend object along it's normals
	
	gl_Position = gl_ProjectionMatrix * gl_Position;
}
