uniform sampler2D tex_unit_0;

varying vec3 nrml, light, eye;

#define LIGHT gl_LightSource[0]
void main()
{
	vec3 L = normalize(light), E = normalize(eye);
	vec3 H = normalize(L + E);
	vec3 N = normalize(nrml);
	
	vec4 diffuse = texture2D(tex_unit_0, gl_TexCoord[0].xy);
	bool lit = light.z > 0.0;
	
	vec2 intens = vec2( dot(N, L), 0.6*pow(dot(N, H), 60.0) );
	intens = float(lit) * max(vec2(0,0), intens);
	
	gl_FragColor = vec4(vec3(intens[0]*vec3(diffuse)+intens[1]) // DIFFUSE + SPECULAR
						 + 0.2*vec3(diffuse) // AMBIENT
						,1.0);
}
