/*************************************************************************
MGLApp.h

Demo for "Planar Reflections" section

Author   :   Andrei Gradinari
Based on Dave Astle's application template

Written for More OpenGL Game Programming
August, 2005
*************************************************************************/

#ifndef MGLAPP_H_INCLUDED
#define MGLAPP_H_INCLUDED

#ifdef WIN32
  #define WIN32_LEAN_AND_MEAN
  #define WIN32_EXTRA_LEAN
  #include <windows.h>
#endif

#include <gl/glee.h>
#include <gl/glu.h>

#include "../../_common/MGLTargaImage.h"
#include "../../_common/MGLTimer.h"
#include "../../_common/MGLTypes.h"
#include "../../_common/MGLVector.h"
#include "../../_common/MGLUtil.h"
#include "../../_common/prim.h"
#include "Camera.h"

// values used to set up the window and rendering context
const char MGL_APP_NAME[]	= "MOGLGP - Chapter Special Effects - Planar Reflections Demo";

const int MGL_WINDOW_WIDTH = 800;
const int MGL_WINDOW_HEIGHT = 600;

const int MGL_COLOR_BITS = 32;
const int MGL_DEPTH_BITS = 24;
const int MGL_STENCIL_BITS = 8;

const bool MGL_FORCE_FULLSCREEN = false;

class MGLApp
{
public:
	MGLApp();
	virtual ~MGLApp();

	bool Init();
	bool Shutdown();
	void SetupProjection( int width, int height );
	void Update( double dt );
	void Render();

private:
	
	void SetupLighting();
	void RenderGeometry();
	bool LoadData();
		
	double m_dElapTime;
	int m_nWindowWidth, m_nWindowHeight;
	MGL::CCamera cam;
	Primitive *m_pMesh[3];
};

#endif // MGLAPP_H_INCLUDED