/*
 *	This file is part of demo program made to accompany
 *	"More OpenGL Game Programming" book's chapter
 *	titled "Robust Multi-Level Reflections".
 *
 *	Author: Maciej Sawitus, 2005
 *	E-mail: msawitus@gmail.com
 *
 */

#ifndef _EXCEPTION_H_
#define _EXCEPTION_H_

/**
 *	Simple exception class.
 */
class cException
{
public:

	/**
	 *	Constructor.
	 *	@param message message to be attached to this exception.
	 */
	cException(const string& message) :
		Message(message)
	{
	}

	/**
	 *	Returns message attached to this exception.
	 *	@return exception message
	 */
	inline const string& getMessage() const
	{
		return Message;
	}

protected:

	/// Exception message
	string Message;
};

#endif //_EXCEPTION_H_