/*
 *	This file is part of demo program made to accompany
 *	"More OpenGL Game Programming" book's chapter
 *	titled "Robust Multi-Level Reflections".
 *
 *	Author: Maciej Sawitus, 2005
 *	E-mail: msawitus@gmail.com
 *
 */

#include "common.h"

#include "Application.h"
#include "MGLApp.h"

/**
 *	Entry point for our application.
 */
int main(int argc, char** argv)
{
	try {

		bool fullScreen = false;
		
		if (/*MGL_FORCE_FULLSCREEN ||*/ MGL_FULLSCREEN_MODE == MGL_FULLSCREEN_TRUE)
			fullScreen = true;
		else if (MGL_FULLSCREEN_MODE == MGL_FULLSCREEN_FALSE)
			fullScreen = false;
		else if (MGL_FULLSCREEN_MODE == MGL_FULLSCREEN_CHOOSE)
		{
#ifdef WIN32
		    fullScreen = (MessageBox(NULL, "Run in fullscreen mode?", MGL_APP_NAME, MB_YESNO | MB_ICONQUESTION) == IDYES);
#endif
		}

		// Create an application and start it
		(new MGLApp(fullScreen))->start();

	} catch (cException& e) {
		fprintf(stderr, "Error caught: %s\n", e.getMessage().data());
		fprintf(stderr, "Quitting...\n");
		return 1;
	}
	
	return 0;
}