/*
 *	This file is part of demo program made to accompany
 *	"More OpenGL Game Programming" book's chapter
 *	titled "Robust Multi-Level Reflections".
 *
 *	Author: Maciej Sawitus, 2005
 *	E-mail: msawitus@gmail.com
 *
 */

#ifndef _COMMON_H_
#define _COMMON_H_

// Note for SDL:
// =============
// Being under Microsoft Visual Studio it's necessary to:
//
// "Set the C runtime to "Multi-threaded DLL" in the menu:
// Project|Settings|C/C++ tab|Code Generation|Runtime Library."
//
// Otherwise you get dirty warnings and errors.

// Win32 specific
#ifdef WIN32

	#define WIN32_LEAN_AND_MEAN
	#define WIN32_EXTRA_LEAN

	// OpenGL
	#pragma comment(lib, "opengl32.lib")
	#pragma comment(lib, "glu32.lib")

	// SDL
	#pragma comment(lib, "../sdl/lib/SDL.lib")
	#pragma comment(lib, "../sdl/lib/SDLmain.lib")

#endif

// SDL headers
#include "../sdl/include/SDL.h"
#include "../sdl/include/SDL_opengl.h"

// STL
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

// Standard libs
#include <math.h>
#include <fstream>
#include <sstream>
#include <iostream>

// Basic classes
#include "Exception.h"
#include "Math.h"
#include "Frustum.h"

#endif //_COMMON_H_