#ifndef SKYBOX_H_INCLUDED
#define SKYBOX_H_INCLUDED

#include <GL/glee.h>

class Skybox
{
public:
  Skybox();
  ~Skybox();

  void Initialize(float size);
  bool LoadTextures(char* top, char* bottom, char* front, char* back, char* left, char* right);
  void Render(float cameraX, float cameraY, float cameraZ);
  void Release();

  enum {
    SKY_TOP,
    SKY_BOTTOM,
    SKY_FRONT,
    SKY_BACK,
    SKY_LEFT,
    SKY_RIGHT
  };

protected:
  GLuint  m_textures[6];		// 6 texture objects
  GLfloat m_size;
  GLuint  m_list;
};

#endif // SKYBOX_H_INCLUDED