/****************************************************************************
 Snowstorm.h  Particle system representing a snowstorm
 
 Author   :   Dave Astle
 Date     :   3/17/2001

 Written for OpenGL Game Programming
*****************************************************************************/
#ifndef SNOWSTORM_H_INCLUDED
#define SNOWSTORM_H_INCLUDED

#include "Particles.h"

const Vector3   SNOWFLAKE_VELOCITY  (0.0f, -3.0f, 0.0f);
const Vector3   VELOCITY_VARIATION  (0.2f, 0.5f, 0.2f);
const float     SNOWFLAKE_SIZE      = 0.02f;
const float     SNOWFLAKES_PER_SEC  = 2000;


class Snowstorm : public ParticleSystem
{
public:
  Snowstorm(int maxParticles, Vector3 origin, float height, float width, float depth);

  void  Update(float elapsedTime);
  void  Render();

  void  InitializeSystem();
  void  KillSystem();

protected:
  void    InitializeParticle(int index);
  float   m_height;
  float   m_width;
  float   m_depth;

  GLuint  m_texture;     // snowflake texture
};


#endif // SNOWSTORM_H_INCLUDED