/*************************************************************************/
/*|=====================================================================|*/
/*| Filename: CParticle_EventChange.cpp                                 |*/
/*| Author: Joel Villagrana    (joel.villagrana@gmail.com)              |*/
/*|                                                                     |*/
/*|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|*/
/*| dd/mm/yyyy | Programmer        | Modifications                      |*/ 
/*|=====================================================================|*/
/*| 17/05/2005 | JVillagrana       | Initial Version                    |*/
/*|---------------------------------------------------------------------|*/
/*************************************************************************/

#ifndef _PARTICLE_EVENTCHG_IMP
#define _PARTICLE_EVENTCHG_IMP

#include <iostream> 
#include <string> 
#include <cstdlib>

#include "CParticle_EventChange.h"

// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
// ========================================================================
// IMPLEMENTATION OF CPARTICLE_EVENTCHANGE
// ========================================================================
// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

// 
// Constructor
// 
template <class T>
CParticle_EventChange_T<T>::CParticle_EventChange_T(int index, EVENT_CHANGE chg,
											float startTime, float endTime)
{
	m_emitterIndex		= index;	
	m_eventChange		= chg;
	m_changeStartTime	= startTime;
	m_changeEndTime		= endTime;	
	m_changeProcessed	= false;
	m_finalValues.reserve(5);
	m_iterator = m_finalValues.begin();
}

// 
// Destructor
// 
template <class T>
CParticle_EventChange_T<T>::~CParticle_EventChange_T()
{
	m_changeProcessed = true;

	for(m_iterator = m_finalValues.begin(); m_iterator != m_finalValues.end();)
	{
		m_iterator = m_finalValues.erase(m_iterator);
	}
} 

// 
// Get Value related info
// 
template <class T>
void CParticle_EventChange_T<T>::GetChangeInfo(int *index, float elapsedTime, 
	EVENT_CHANGE *eventType, int *finished, int *fade, float *start, float *end)
{
	*index		= m_emitterIndex;
	*eventType	= m_eventChange;
	*finished	= 0;
	*start		= m_changeStartTime;
	*end		= m_changeEndTime;
	
	if(m_changeStartTime != m_changeEndTime)
		*fade = 1;
	
	if(elapsedTime >= m_changeEndTime)
	{
		*finished = 1;
		m_changeProcessed = true;
	}
}

// 
// Get
// 
template <class T>
T CParticle_EventChange_T<T>::GetVal()
{
	T val;
	if(m_iterator != m_finalValues.end())
	{
		val = (*m_iterator);
		m_iterator++;
	}
	return val;
}

// 
// Add
// 
template <class T>
bool CParticle_EventChange_T<T>::AddVal(T const& elem)
{	
	m_finalValues.push_back(elem);
	return true;
}

// ------------------------- END OF FILE -----------------------------------
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#endif _PARTICLE_EVENTCHG_IMP
