/*************************************************************************/
/*|=====================================================================|*/
/*| Filename: GLFont.h  												|*/
/*| Author: Joel Villagrana    (joel.villagrana@gmail.com)              |*/
/*|                                                                     |*/
/*| Classes Defined:	                                                |*/
/*| GLFont																|*/
/*| (mostly font stuff taken from NeHe)                                 |*/
/*|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|*/
/*| dd/mm/yy   | Programmer        | Modifications                      |*/ 
/*|=====================================================================|*/
/*| 11/03/04   | JVillagrana       | Initial Version                    |*/
/*************************************************************************/

#ifndef _OPENGL_FONT
#define _OPENGL_FONT

#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include "../texture/textureManager.h"

/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
================================================================================
	Definition of the GLFont Class
================================================================================
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/
class GLFont
{
private:
	GLuint	m_fontList;	
	GLuint	m_textureID;

public:
	GLFont();
	~GLFont();

	HRESULT InitAll();
	HRESULT DestroyAll();
	VOID	PrintScreen(GLfloat r, GLfloat g, GLfloat b, GLfloat a, 
										GLint x, GLint y, const char *fmt, ...);
	bool	CreateGLFont(char *texturePath);
	GLuint	GetTextureID(){ return m_textureID; }
};
// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 

#endif _OPENGL_FONT