#ifndef _APPHELPER_H
#define _APPHELPER_H

#include <windows.h>
#define STD_FILENAME_LEN 150


/* ------------------------------------------------------------ */

enum CLASSIFY
{
	D_OUTSIDE,
	D_INSIDE
}; 

/* ------------------------------------------------------------ */

enum FRUSTUMSIDE
{
	P_FRONT,
	P_RIGHT,
	P_LEFT,
	P_TOP,
	P_BOTTOM,
	P_BACK
};

/* ------------------------------------------------------------ */

enum HALFSPACE
{ 
	NEGATIVE = -1, 
	ON_PLANE = 0, 
	POSITIVE = 1 
};

/* ------------------------------------------------------------ */

enum OC3NODEID
{
	ROOT				= -1,
	TOP_LEFT_FRONT		=  0,
	BOTTOM_LEFT_FRONT	=  1,
	BOTTOM_RIGHT_FRONT	=  2,
	TOP_RIGHT_FRONT		=  3,
	TOP_LEFT_BACK		=  4,
	BOTTOM_LEFT_BACK	=  5,
	BOTTOM_RIGHT_BACK	=  6,
	TOP_RIGHT_BACK		=  7
};

/* ------------------------------------------------------------ */

enum BOUNDINGBOX_SIDE
{
	TOP,
	BOTTOM,
	LEFT,
	RIGHT,
	FRONT,
	BACK
};

/* ------------------------------------------------------------ */

enum BSPTREENODE_ID
{
	BSP_NO_ID,
	BSP_ROOT,
	BSP_RIGHT_CHILD,
	BSP_LEFT_CHILD,
	BSP_RIGHT_LEAF,
	BSP_LEFT_LEAF
};

/* ------------------------------------------------------------ */

enum POLYGON_SIDE
{
	IN_FRONT,
	BEHIND,
	COINCIDENT,
	SPANNING
};
/* ------------------------------------------------------------ */

enum PARTICLE_REP
{
	R_POINTS=0,
	R_LINES,
	R_QUADS,
	R_POINT_SPRITES
};

/* ------------------------------------------------------------ */

enum PARTICLESYS_TYPE
{
	PSYS_INVALIDSYS=0,
	PSYS_SMOKE,
	PSYS_SNOW,
	PSYS_SPARKS,
	PSYS_RAIN,
	PSYS_DUST,
	PSYS_SCRIPTABLE
};

/* ------------------------------------------------------------ */

enum PSYS_EMITTERTYPE
{
	E_LINE=0,
	E_POINT,
	E_SPHERE,
	E_BEAM,
	E_RING
};

/* ------------------------------------------------------------ */

enum EVENT_CHANGE
{
	PA_SIZE=0,
	PA_COLOR,
	PA_WEIGHT,
	EM_BATCHSIZE,
	EM_EMISSIONRATE,
	EM_TEXTURE,
	EM_POSITION,
	EM_BLENDING,
	EM_VERTEXSH,
	EM_PIXELSH,
	EM_STATE,
	EM_FORCE,
	SYS_FORCE
};

/* ------------------------------------------------------------ */

#endif _APPHELPER_H


// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% END OF FILE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




