
/*************************************************************************
fontprint.cpp

OpenGL texture based text rendering class

Author   :   Angus Dorbie

Published for More OpenGL Game Programming
*************************************************************************/

#include "fontprint.h"

fontprint::fontprint()
{
	int i;

	glGenTextures(1, &tex_handle);
	glBindTexture(GL_TEXTURE_2D, tex_handle);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	if(GLEE_EXT_texture_filter_anisotropic)
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT, 4);

	MGL::TargaImage fontImage;
	if(fontImage.Load("..\\Textures\\font.tga"))
	{
		// convert image to alpha and load as texture (commented code converts to luminance alpha)
		int x_image = fontImage.GetWidth();
		int y_image = fontImage.GetHeight();
		unsigned char* data_image = fontImage.GetImage();
		for(i = 0; i < x_image * y_image; i++)
		{
			//alpha
			data_image[i] = data_image[i*3];
			//luminance alpha
			//data_image[i*2+1] = data_image[i*3];
			//data_image[i*2] = 0xFF;
		}
		glTexImage2D(GL_TEXTURE_2D, 0, GL_ALPHA, x_image, y_image, 0, GL_ALPHA, GL_UNSIGNED_BYTE, data_image);
		//glTexImage2D(GL_TEXTURE_2D, 0, GL_INTENSITY_ALPHA, fontImage.GetWidth(), fontImage.GetHeight(), 0, GL_INTENSITY_ALPHA, GL_UNSIGNED_BYTE, data_image);
	}
	fontImage.Release();
}

fontprint::~fontprint()
{
}

void fontprint::displayStr(char *text)
{
	int i;
	float char_s, char_t;
	// 1/16th s & t = 1 letter 0.0625

	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, tex_handle);
	for(i = 0; text[i] != '\0';i++)
	{
		char_s = 0.0625f*(float)((text[i])%16);
		char_t = 1.0f - (text[i]/16-1) * 0.0625f;
		//if(GUI_Font)
			char_t -=0.496f;
		glBegin(GL_TRIANGLE_STRIP);
		glTexCoord2f(char_s, char_t);
		glVertex3f((float) i, 0.0f, 0.0f);
		glTexCoord2f(char_s, char_t+0.054f);
		glVertex3f((float) i, 1.45f, 0.0f);
		glTexCoord2f(char_s+0.0625f, char_t);
		glVertex3f((float) i + 1.5f, 0.0f, 0.0f);
		glTexCoord2f(char_s+0.0625f, char_t+0.054f);
		glVertex3f((float) i + 1.5f, 1.45f, 0.0f);
		glEnd();
	}
}