/*************************************************************************
gui.cpp

OpenGL based Menu style GUI, quick & dirty
just hacked C code migrated from an earlier unpublished project

Author   :   Angus Dorbie

Published for More OpenGL Game Programming
*************************************************************************/


#include <stdio.h>
#include <math.h>
#include <string.h>
#include <glee.h>
#include "fontprint.h"
#include "fontprint.h"

#define DEGTORAD 0.0174532925199f
#define M_PI 3.1415926535897932f


float dtime = 0.0f;
float BackgroundAngle = 0.0f;
float LightAngle1 = 0.0f;
float LightAngle2 = 9.0f;
float TitleX = 0.05f;
float TitleY = 0.05f;


float gui_left = -10.0f;
float gui_right = 65.0f;
float gui_bottom = -65.0f;
float gui_top = 10.0f;

float GUI_Author = 0.0f;
int GUI_switch_author = 0;
int GUI_Font = 0;
int GUI_Light1 = 1;
int GUI_Light2 = 1;
int GUI_Light3 = 1;
int GUI_Light4 = 1;
float GUI_Red = 0.7f;
float GUI_Green = 0.7f;
float GUI_Blue = 0.7f;
int GUI_div = 10;
int GUI_bevel = 1;
int GUI_texture = 0;
int Running = 1;

int MOUSE_CAPTURE = 1;

static LPCTSTR lpszAppName = "OpenGL Challenge GUI";

fontprint *gui_text;

#define MAXBUTTONS 100

typedef struct
{
	float xpos, ypos;
	float width;
	float value;
	int ivalue;
	int type;
	int startmenu, stopmenu;
	char label[40];
	char layout[40];
} Button;
static Button button_array[MAXBUTTONS];

int MenuIN = 0;
int MenuOUT = 0;
int MenuFocus = 0;
int MenuGrab = -1;
float frustM_X = 0.0f;
float frustM_Y = 0.0f;


void PrintString(char *text)
{
	gui_text->displayStr(text);
}

void DrawButton(int number, Button *button)
{
	double angle;
	double divinc;
	float pos[100][3];
	float tpos[100][2];
	float norm[100][3];
	float pos2[100][3];
	float tpos2[100][2];
	int i;

	float Mcolor1[4] = {1.0f, 1.0f, 1.0f, 0.5f};
	float Mcolor2[4] = {1.0f, 1.0f, 1.0f, 1.0f};
	float Mcolor3[4] = {0.0f, 0.0f, 0.0f, 1.0f};
	float Mcolor4[4] = {1.0f, 1.0f, 1.0f, 1.0f};
	float Mcolor5[4] = {1.0f, 0.0f, 0.0f, 1.0f};
	float Mcolor6[4] = {0.5f, 1.0f, 0.5f, 1.0f};

	Mcolor1[0] = Mcolor2[0] = GUI_Red;
	Mcolor1[1] = Mcolor2[1] = GUI_Green;
	Mcolor1[2] = Mcolor2[2] = GUI_Blue;

	glPushMatrix();
	glTranslatef(button->xpos, button->ypos, -7.0f);

	if(MenuFocus == number)
	{
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, Mcolor2);
	}
	else
	{
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, Mcolor1);
	}

	glNormal3f(0.0f, 0.0f, 1.0f);
	if(GUI_texture)
		glBindTexture(GL_TEXTURE_2D, 2);
	else
		glDisable(GL_TEXTURE_2D);

	divinc = M_PI/GUI_div;

	// calculate coords
	for(i = 0, angle = 0.0; angle < M_PI+.01; i++, angle += divinc)
	{
		// inside
		pos[i][0] = (float)sin(angle) + button->width*0.5f;
		pos[GUI_div+GUI_div+1-i][0] = -pos[i][0];
		pos[GUI_div+GUI_div+1-i][1] = pos[i][1] = (float)cos(angle);
		pos[GUI_div+GUI_div+1-i][2] = pos[i][2] = 0.0f;
		tpos[i][0] = pos[i][0] * 0.3f;
		tpos[i][1] = pos[i][1] * 0.3f;
		tpos[GUI_div+GUI_div+1-i][0] = pos[GUI_div+GUI_div+1-i][0] * 0.3f;
		tpos[GUI_div+GUI_div+1-i][1] = pos[GUI_div+GUI_div+1-i][1] * 0.3f;

		if(GUI_bevel)
		{
			// normals
			norm[GUI_div+GUI_div+1-i][0] = norm[i][0] = (float)sin(angle) * 0.707f;
			norm[GUI_div+GUI_div+1-i][1] = norm[i][1] = (float)cos(angle) * 0.707f;
			norm[GUI_div+GUI_div+1-i][2] = norm[i][2] = 0.707f;

			// outside
			pos2[i][0] = (float)sin(angle) * 1.15f + button->width*0.5f;
			pos2[GUI_div+GUI_div+1-i][0] = -pos2[i][0];
			pos2[GUI_div+GUI_div+1-i][1] = pos2[i][1] = (float)cos(angle) * 1.15f;
			pos2[GUI_div+GUI_div+1-i][2] = pos2[i][2] = -0.05f;
			tpos2[i][0] = pos2[i][0] * 0.3f;
			tpos2[i][1] = pos2[i][1] * 0.3f;
			tpos2[GUI_div+GUI_div+1-i][0] = pos2[GUI_div+GUI_div+1-i][0] * 0.3f;
			tpos2[GUI_div+GUI_div+1-i][1] = pos2[GUI_div+GUI_div+1-i][1] * 0.3f;
		}
	}

	// special author button animation
	if(number == 24)
		glRotatef(GUI_Author, 0.0f, 1.0f, 0.0f);

	// draw centre
	glBegin(GL_TRIANGLE_FAN); 
	for(i=0; i<GUI_div+GUI_div+2; i++)
	{
		glTexCoord2fv(tpos[i]);
		glVertex3fv(pos[i]);
	}
	glEnd();
	if(GUI_bevel)
	{
		// draw outside
		glBegin(GL_TRIANGLE_STRIP); 
		for(i=0; i<GUI_div+GUI_div+2; i++)
		{
			glNormal3fv(norm[i]);
			glTexCoord2fv(tpos[i]);
			glVertex3fv(pos[i]);
			glTexCoord2fv(tpos2[i]);
			glVertex3fv(pos2[i]);
		}
		glNormal3fv(norm[0]);
		glTexCoord2fv(tpos[0]);
		glVertex3fv(pos[0]);
		glTexCoord2fv(tpos2[0]);
		glVertex3fv(pos2[0]);
		glEnd();

		glNormal3f(0.0f, 0.0f, 1.0f);
	}

	if(!GUI_texture)
		glEnable(GL_TEXTURE_2D);

	// draw slider bar
	if(button->type == 2)
	{
		glPushMatrix();
		glTranslatef(-button->width*0.5f-0.75f + button->width*button->value, -1.5f, 0.0f);
		glScalef(1.0f, 2.1f, 1.0f);
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, Mcolor3);
		PrintString("|");
		glTranslatef(-0.05f, 0.05f, 0.0f);
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, Mcolor2);
		PrintString("|");
		glPopMatrix();
	}

	// draw text
	glTranslatef(-button->width*0.5f-0.2f, -0.75f, 0.0f);
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, Mcolor3);
	PrintString(button->label);
	if(MenuIN == number)
	{
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, Mcolor6);
	}
	else
		if(MenuFocus == number)
		{
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, Mcolor5);
		}
		else
		{
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, Mcolor4);
		}
		if(number == MenuGrab)
		{
			glTranslatef(-0.05f, 0.05f, 0.0f);
		}
		else
		{
			glTranslatef(-0.1f, 0.1f, 0.0f);
		}
		PrintString(button->label);


		glPopMatrix();
}

void GUI_Init(fontprint *init_text)
{
	int i;

	gui_text = init_text;

	// set up the menu tree
	MenuIN = 0;
	MenuOUT = 6;
	MenuFocus = 1;

	for(i = 0; i<6;i++)
	{
		button_array[i].ypos = 8.5f - (float)i*3.0f;
		button_array[i].xpos = 0.0f;
		button_array[i].type = 1;
		button_array[i].startmenu = 0;
		button_array[i].stopmenu = 6;
	}
	strcpy(button_array[0].label, "Main Menu");
	strcpy(button_array[1].label, "Sky Color");
	button_array[1].startmenu = 6;
	button_array[1].stopmenu = 11;
	strcpy(button_array[2].label, "Water Color");
	button_array[2].startmenu = 11;
	button_array[2].stopmenu = 17;
	strcpy(button_array[3].label, "Polarize Filter");
	button_array[3].startmenu = 0;
	button_array[3].stopmenu = 6;
	strcpy(button_array[4].layout, "< Wave Amplitude >");
	button_array[4].type = 2;
	sprintf(button_array[4].label, button_array[4].layout, button_array[4].value);
	strcpy(button_array[5].label, "Author");
	button_array[5].startmenu = 17;
	button_array[5].stopmenu = 20;

	for(i = 6; i<11;i++)
	{
		button_array[i].ypos = 8.5f - (float)(i-6)*3.0f;
		button_array[i].xpos = 0.0f;
		button_array[i].type = 1;
		button_array[i].startmenu = 6;
		button_array[i].stopmenu = 11;
	}
	strcpy(button_array[6].label, "Sky Color");
	strcpy(button_array[7].layout, "< Red   %.2f >");
	button_array[7].type = 2;
	button_array[7].value = GUI_Red;
	sprintf(button_array[7].label, button_array[7].layout, button_array[7].value);

	strcpy(button_array[8].layout, "< Green %.2f >");
	button_array[8].type = 2;
	button_array[8].value = GUI_Green;
	sprintf(button_array[8].label, button_array[8].layout, button_array[8].value);

	strcpy(button_array[9].layout, "< Blue  %.2f >");
	button_array[9].type = 2;
	button_array[9].value = GUI_Blue;
	sprintf(button_array[9].label, button_array[9].layout, button_array[9].value);

	strcpy(button_array[10].label, "Back");
	button_array[10].startmenu = 0;
	button_array[10].stopmenu = 6;

	for(i = 11; i<17;i++)
	{
		button_array[i].ypos = 8.5f - (float)(i-11)*3.0f;
		button_array[i].xpos = 0.0f;
		button_array[i].type = 1;
		button_array[i].startmenu = 11;
		button_array[i].stopmenu = 17;
	}
	strcpy(button_array[11].label, "Water Color");
	strcpy(button_array[12].layout, "< Red   %.2f >");
	button_array[12].type = 2;
	button_array[12].value = GUI_Red;
	sprintf(button_array[12].label, button_array[12].layout, button_array[12].value);

	strcpy(button_array[13].layout, "< Green %.2f >");
	button_array[13].type = 2;
	button_array[13].value = GUI_Green;
	sprintf(button_array[13].label, button_array[13].layout, button_array[13].value);

	strcpy(button_array[14].layout, "< Blue  %.2f >");
	button_array[14].type = 2;
	button_array[14].value = GUI_Blue;
	sprintf(button_array[14].label, button_array[14].layout, button_array[14].value);

	strcpy(button_array[15].layout, "< Turbidity %.2f >");
	button_array[15].type = 2;
	button_array[15].value = GUI_Blue;
	sprintf(button_array[15].label, button_array[15].layout, button_array[15].value);

	strcpy(button_array[16].label, "Back");
	button_array[16].startmenu = 0;
	button_array[16].stopmenu = 6;

	for(i = 17; i<20;i++)
	{
		button_array[i].ypos = 8.5f - (float)(i-17)*3.0f;
		button_array[i].xpos = 0.0f;
		button_array[i].type = 1;
		button_array[i].startmenu = 0;
		button_array[i].stopmenu = 6;
	}
	strcpy(button_array[17].label, "Author");
	strcpy(button_array[18].label, "Angus Dorbie");
	button_array[18].startmenu = 17;
	button_array[18].stopmenu = 20;
	strcpy(button_array[19].label, "Back");
	button_array[19].startmenu = 0;
	button_array[19].stopmenu = 6;
	for(i = 0; i<20;i++)
	{
		button_array[i].width = (float)strlen(button_array[i].label);
	}

}

void GUI_Draw(void)
{
	int i;
	float lpos[4] = {1.0f, 1.0f, 2.0f, 0.0f};

	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glLightfv(GL_LIGHT0, GL_POSITION, lpos);
	glEnable(GL_LIGHTING);

	// draw buttons
	for(i = MenuIN; i<MenuOUT;i++)
	{
		DrawButton(i, &button_array[i]);
	}

	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
}

int PointInside(Button * butt, float x, float y)
{
	if(y > butt->ypos-1.0f && y < butt->ypos+1.0f)
	{
		if(x > butt->xpos-butt->width*0.5f-1.0f && x < butt->xpos+butt->width*0.5f+1.0f)
		{
			if(x > butt->xpos-butt->width*0.5f && x < butt->xpos+butt->width*0.5f)
			{
				return TRUE;
			}
			if((butt->xpos-butt->width*0.5f-x) * (butt->xpos-butt->width*0.5f-x) +
				(y - butt->ypos) * (y - butt->ypos) < 1.0f)
			{
				return TRUE;
			}
			if((butt->xpos+butt->width*0.5f-x) * (butt->xpos+butt->width*0.5f-x) +
				(y - butt->ypos) * (y - butt->ypos) < 1.0f)
			{
				return TRUE;
			}
		}
	}
	return FALSE;
}

bool *gui_polarize;
float *gui_Amplitude;
float *gui_SkyColor;
float *gui_WaterColor;
float *gui_Fog;

void GUI_SetPolarize(bool *val_ptr)
{
	gui_polarize = val_ptr;

}

void GUI_SetAmplitude(float *val_ptr)
{
	button_array[4].value = *val_ptr;

	sprintf(button_array[4].label, button_array[4].layout, button_array[4].value);


	gui_Amplitude = val_ptr;
}

void GUI_SetSkyColor(float *val_ptr)
{
	button_array[7].value = *val_ptr;
	button_array[8].value = *(val_ptr+1);
	button_array[9].value = *(val_ptr+2);

	sprintf(button_array[7].label, button_array[7].layout, button_array[7].value);
	sprintf(button_array[8].label, button_array[8].layout, button_array[8].value);
	sprintf(button_array[9].label, button_array[9].layout, button_array[9].value);


	gui_SkyColor = val_ptr;
}

void GUI_SetWaterColor(float *val_ptr)
{
	button_array[12].value = *val_ptr;
	button_array[13].value = *(val_ptr+1);
	button_array[14].value = *(val_ptr+2);
	sprintf(button_array[12].label, button_array[12].layout, button_array[12].value);
	sprintf(button_array[13].label, button_array[13].layout, button_array[13].value);
	sprintf(button_array[14].label, button_array[14].layout, button_array[14].value);

	gui_WaterColor = val_ptr;
}

void GUI_SetFog(float *val_ptr)
{
	button_array[15].value = *val_ptr;
	sprintf(button_array[15].label, button_array[15].layout, button_array[15].value);

	gui_Fog = val_ptr;
}

void ChooseButton(void)
{
	if(MenuFocus == 3)
		*gui_polarize = !*gui_polarize;


	if(MenuIN != button_array[MenuFocus].startmenu)
	{
		MenuIN = button_array[MenuFocus].startmenu;
		MenuOUT = button_array[MenuFocus].stopmenu;
		MenuFocus = MenuIN+1;
	}

}

void SeekMouseFocus()
{
	int i;
	if(MenuGrab < 0)
	{
		for(i = MenuIN+1; i < MenuOUT; i++)
		{
			if(PointInside(&button_array[i], frustM_X, frustM_Y))
			{
				if(MenuFocus != i)
				{
					MenuFocus = i;
				}
			}
		}
	}
}

void SliderValue(void)
{
	button_array[MenuGrab].value = (frustM_X - (button_array[MenuGrab].xpos - button_array[MenuGrab].width*0.5f))
		/ button_array[MenuGrab].width;
	if(button_array[MenuGrab].value < 0.0f)
		button_array[MenuGrab].value = 0.0f;
	if(button_array[MenuGrab].value > 1.0f)
		button_array[MenuGrab].value = 1.0f;

	/*
	if(MenuGrab == 19)
	{
		button_array[MenuGrab].ivalue = (int)(button_array[MenuGrab].value * 10.0f + 1.5f);
		sprintf(button_array[MenuGrab].label, button_array[MenuGrab].layout, button_array[MenuGrab].ivalue);
		GUI_div = button_array[MenuGrab].ivalue;
	}
	else
	*/

	sprintf(button_array[MenuGrab].label, button_array[MenuGrab].layout, button_array[MenuGrab].value);

	if(MenuGrab == 4)
		*gui_Amplitude = button_array[MenuGrab].value;

	if(MenuGrab == 7)
		*gui_SkyColor = button_array[MenuGrab].value;
	if(MenuGrab == 8)
		*(gui_SkyColor+1) = button_array[MenuGrab].value;
	if(MenuGrab == 9)
		*(gui_SkyColor+2) = button_array[MenuGrab].value;

	if(MenuGrab == 12)
		*gui_WaterColor = button_array[MenuGrab].value;
	if(MenuGrab == 13)
		*(gui_WaterColor+1) = button_array[MenuGrab].value;
	if(MenuGrab == 14)
		*(gui_WaterColor+2) = button_array[MenuGrab].value;

	if(MenuGrab == 15)
		*gui_Fog = button_array[MenuGrab].value;
}


void GUI_MouseMove(float x_pos, float y_pos)
{
		frustM_X = (gui_right - gui_left) * x_pos + gui_left;
		frustM_Y = (gui_top - gui_bottom) * y_pos + gui_bottom;

		SeekMouseFocus();

		if(MenuGrab > 0)
		{
			if(button_array[MenuGrab].type == 2) // sliders only
			{
				SliderValue();
			}
		}
}


void GUI_LeftButtonDown(void)
{
		//sprintf(button_array[0].label, "BUTTON DOWN");
		if(PointInside(&button_array[MenuFocus], frustM_X, frustM_Y))
		{
			MenuGrab = MenuFocus;
			if(button_array[MenuGrab].type == 2) // sliders only
			{
				SliderValue();
			}
		}
		else
		{
			MenuGrab = -1;
		}
}

void GUI_LeftButtonUp(void)
{
		//sprintf(button_array[0].label, "BUTTON UP");
		if(PointInside(&button_array[MenuGrab], frustM_X, frustM_Y))
		{
			ChooseButton();
		}
		MenuGrab = -1;
		SeekMouseFocus();
}

