/*************************************************************************
MGLNoise.h

Perlin Noise class.

Author   :  Baldur Karlsson

Written for More OpenGL Game Programming
*************************************************************************/

#ifndef MGLNOISE_H_INCLUDED
#define MGLNOISE_H_INCLUDED

#include <math.h>
#include "MGLMath.h"

class MGLNoise
{
 public:
    MGLNoise() { for(int i=0; i < 256*256; i++) noise[i] = 0.0f; }
    void Generate();

    float operator [](int idx) { return noise[idx]; }
 private:
    float Noise2D(int x, int y);
    float SmoothedNoise2D(int x, int y);
    float Interpolate1D(float a, float b, float x);
    float InterpolatedNoise2D(float x, float y);

    float noise[256*256];
};

#endif // MGLNOISE_H_INCLUDED
