/*************************************************************************
MGLCamera.h

OpenGL Camera Implementation, for SDL and Win32.

Author   :   Andrei Stojan, Dimi Christopoulos

Written for More OpenGL Game Programming
*************************************************************************/
#ifndef _CAM_H
#define _CAM_H

class MGLCamera {

public:

	MGLCamera();

	Vector3 GetCameraUpVector() {	return UpVector;		}
	Vector3 GetCameraView() { return View; }
	Vector3 GetCameraPosition() { return Position; }
			
	void PositionCamera(float positionX, float positionY, float positionZ,
			 		    float viewX,     float viewY,     float viewZ,
						float upVectorX, float upVectorY, float upVectorZ);

	void SetSpeed(float sp) { Speed = sp; }	
	void SetView(Vector3 v) { View = v; }
	void Reset();
	void Update();

private:
	
	void SetViewByMouse(); 	
	void CheckForMovement();
	void StrafeCamera(float);
	void MoveCamera(float);
	void RotateView(float angle, float x, float y, float z);

	float	Speed;

	Vector3 Position;					
	Vector3 View;						
	Vector3 UpVector;		
	Vector3 LookAt;
	Vector3 Strafe;
	
	float CurrentRot;
	
	int 	ScreenWidth, ScreenHeight;			
};

#endif
