/*************************************************************************
glCamera.h

Camera Class.

Author   :   Dimi Christopoulos

*************************************************************************/
#ifndef GL_CAMERA_H
#define GL_CAMERA_H

#include "tvector.h"

class GLCamera
{
    private:
        //camera position,direction and up vector
        TVector32 _CamPos; 
	TVector32 _Direction; 
	TVector32 _Up;
	
    public:
        GLCamera() : _CamPos(TVector32(0, 0, 0)), _Direction(TVector32(0, 0, -1)), _Up(TVector32(0, 1, 0)) {}
	
	void setPos (float x, float y, float z);
	void setCamTarget (float x, float y, float z);
	void setHeadPitch (float heading, float pitch);
	void addPos (float x, float y, float z);
	void rotateY (const float angle);
	void rotateAxis (const float angle);
        void move (float amount);
	
	TVector32 getPos (){return _CamPos;}
	TVector32 getDir (){return _Direction;}
	TVector32 getUp (){return _Up;}
	TVector32 getCamTarget (const float distance) {return _CamPos + (_Direction*distance);}
};
#endif
