#ifndef TEXTURE_H
#define TEXTURE_H
/*
 * read_rgbtexture() - read in an image file in SGI 'libimage' format
 * 	currently its very simple minded and converts all images
 *      to RGBA8 regardless of the input format and returns the
 *	original number of components in the appropriate parameter.
 *    
 *     
 *	the components are converted as follows
 *		L    -> LLL 1.0
 *		LA   -> LLL A
 *		RGB  -> RGB 1.0
 *		RGBA -> RGB A
 *
 */
unsigned char * read_rgbtexture(char *name, int *width, int *height, int *components);

/* write_rgbtexture() - write a sgi image in Verbatim non RLE, 1 byte per pixel format. 
 * The buffer must be in RGB,RGBA,LA, or L mode
 */
int write_rgbtexture(char *name, unsigned char *buffer, int width, int height, int components);

/*
 * help function to convert from RGBA to Grayscale
 *
 */
void RGBAtoGrayscale(unsigned char *texbuffer, int width, int height, int components);

/*
 * read_bmptexture() - read in an image file in BMP format.
 *
 */
unsigned char *read_bmptexture(char *filename, int *width, int *height, int *components); 

#endif
