////////////////////////////////////////////////////////////////////////////
///	\File "CTerrainQuadLOD.cpp"
//
///	Author: Brian Story
//
///	Creation Date: 5/26/2005
//
///	Purpose: Implimentation of the CTerrainQuadLOD class.
////////////////////////////////////////////////////////////////////////////

#include "CTerrainQuadLOD.h"



//////////////////////////////////////////////////////////
///	Function: "createColors"
//
///	FirstModified: 5/27/2005
//
///	\param None
//
///	Output: None
//
///	\return None
//
///	Purpose: Creates vertex colors for the heightmap.
//////////////////////////////////////////////////////////
void CTerrainQuadLOD::createColors(void)
{
	// Create Colors.
	for (int y = 0; y < Height; y++)
	{
		for (int x = 0; x < Width; x++)
		{
			// Color tests.
			GLubyte r1 = 0;
			GLubyte g1 = 128;
			GLubyte b1 = 0;

			GLubyte r2 = 128;
			GLubyte g2 = 100;
			GLubyte b2 = 0;

			GLubyte r3 = 192;
			GLubyte g3 = 192;
			GLubyte b3 = 192;

			double alpha = min(1, (max (0, data[x][y].y - 32)) / 32.0f);
	
			data[x][y].color.r = alpha * r2 + (1 - alpha) * r1;
			data[x][y].color.g = alpha * g2 + (1 - alpha) * g1;
			data[x][y].color.b = alpha * b2 + (1 - alpha) * b1;
			data[x][y].color.a = 255;

			alpha = 1 - data[x][y].normal.y;

			data[x][y].color.r = alpha * r3 + (1 - alpha) * data[x][y].color.r;
			data[x][y].color.g = alpha * g3 + (1 - alpha) * data[x][y].color.g;
			data[x][y].color.b = alpha * b3 + (1 - alpha) * data[x][y].color.b;
		}
	}
}
