/*
** basic_mesh.cpp
**
** Copyright (C) 2005 Wael EL ORAIBY
**
** basic mesh methods (setup and rendering)
**
** Written for More OpenGL Game Programming
*/

#include "GLee.h"
#include <GL/gl.h>
#include <GL/glu.h>

#include <iostream>
#include <vector>
#include <map>
#include <string>

#include "algebra3.h"
#include "geom.h"
#include "scene_map.h"

using namespace std;
using namespace SceneMap;

/*
** Setup the vertices and faces of a MapMesh object and compute bounding volumes
*/
void BasicMesh::setup(int _numVerts, vec3* _verts, int _numFaces, int* _faces)
{
	if (verts)
		delete[] verts;
	if (faces)
		delete[] faces;

	numVerts	= _numVerts; numFaces	= _numFaces;
	verts		= _verts; faces	= _faces;

	// setup bounding volume
	bv.setup(numVerts, verts);
}

/*
** render the mesh
*/
void BasicMesh::glRender() const
{
	glVertexPointer(3, GL_FLOAT, 0, verts);
	glEnableClientState(GL_VERTEX_ARRAY);
	glDrawElements(GL_TRIANGLES, numFaces * 3, GL_UNSIGNED_INT, faces);
}

