/*
** font.h
**
** Copyright (C) 2005 Wael EL ORAIBY
**
** basic font class
**
** Written for More OpenGL Game Programming
*/
#pragma once

// start text mode
void textBegin(int width, int height);

// end text mode
void textEnd();

class Font {
private:
	GLuint		texId;			// GL texture id
	
	float		charHeight;		// char height/width
	float		drawSize;		// drawing size
	float		charWidth[256];	// all character widths

	float		cursorX, cursorY;	// cursor
	
	// draw a char
	void		drawChar(unsigned char ch);

	// compute all chars width
	void computeCharWidth(int size, unsigned char *data);

public:
	// constructor & destructor
	Font(const char *name);
	~Font();

	// draw a text string
	void		drawText(const char *str);

	// set the text cursor
	void		setCursor(float x, float y);

	// set drawing size
	void		setSize(float size) { drawSize = size; }
};
