/*************************************************************************/
/*|=====================================================================|*/
/*| Filename: CColor.cpp                                                |*/
/*| Author: Joel Villagrana   (joel.villagrana@gmail.com)               |*/
/*|                                                                     |*/
/*| Implemented Classes:                                                |*/
/*| CColour                                                             |*/
/*|                                                                     |*/
/*|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|*/
/*| dd/mm/yy   | Programmer        | Modifications                      |*/ 
/*|=====================================================================|*/
/*| 11/03/04   | JVillagrana       | Initial Version                    |*/
/*************************************************************************/

//#include "../stdafx.h"

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "CColor.h"

/*
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%###################################################################################%
%#																				   #%	
%#		IMPLEMENTATION OF THE CColour CLASS METHODS								   #%
%#																				   #%
####################################################################################%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
// ==================================================================================
// CONSTRUCTOR 1
// ==================================================================================
// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
CColour::CColour()
{
	m_red		= 57;
	m_green		= 57;
	m_blue		= 57;
	m_alpha		= 255;
	ConvertToOGLFloat();
}

// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
// ==================================================================================
// CONSTRUCTOR 2
// ==================================================================================
// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
CColour::CColour(GLuint r, GLuint g, GLuint b)
{
	m_red		= r;
	m_green		= g;
	m_blue		= b;
	m_alpha		= 255;
	ConvertToOGLFloat();
}

// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
// ==================================================================================
// CONSTRUCTOR 3
// ==================================================================================
// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
CColour::CColour(GLuint r, GLuint g, GLuint b, GLuint a)
{
	m_red		= r;
	m_green		= g;
	m_blue		= b;
	m_alpha		= a;
	ConvertToOGLFloat();
}

// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
// ==================================================================================
// DESTRUCTOR 
// ==================================================================================
// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
CColour::~CColour()
{
	m_red		= 0;
	m_green		= 0;
	m_blue		= 0;
	m_alpha		= 0;
	ConvertToOGLFloat();
}

// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
// ==================================================================================
// CONVERT COLOURS TO RANGE 0-1
// ==================================================================================
// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
VOID CColour::ConvertToOGLFloat()
{
	m_glRed		= (GLfloat)(m_red/255.0f);
	m_glGreen	= (GLfloat)(m_green/255.0f);
	m_glBlue	= (GLfloat)(m_blue/255.0f);
	m_glAlpha	= (GLfloat)(m_alpha/255.0f);
}

// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
// ==================================================================================
// SET COLOR RGB
// ==================================================================================
// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
VOID CColour::Set_ColourRGB( GLuint r, GLuint g, GLuint b )
{
	m_red		= r;
	m_green		= g;
	m_blue		= b;
	m_alpha		= 255;
	ConvertToOGLFloat();
}

// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
// ==================================================================================
// OVERLOAD = OPERATOR
// ==================================================================================
// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
VOID CColour::operator =(CColour& c2)
{
	m_red		= c2.m_red;
	m_green		= c2.m_green;
	m_blue		= c2.m_blue;
	m_alpha		= c2.m_alpha;
	ConvertToOGLFloat();
}

// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
// ==================================================================================
// SET COLOR RGBA
// ==================================================================================
// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
VOID CColour::Set_ColourRGBA( GLuint r, GLuint g, GLuint b, GLuint a )
{
	m_red		= r;
	m_green		= g;
	m_blue		= b;
	m_alpha		= a;
	ConvertToOGLFloat();
}

// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
// ==================================================================================
// RANDOM COLOR...
// ==================================================================================
// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
VOID CColour::GenerateRandomColour()
{
	m_red		= rand() % 255;
	m_green		= rand() % 255;
	m_blue		= rand() % 255;
	m_alpha		= 255;
	ConvertToOGLFloat();
}

// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
// ==================================================================================
// DECREASE ALPHA
// ==================================================================================
// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
VOID CColour::UpdateAlpha(int a)
{
	m_alpha = a;
	if(m_alpha < 0)
		m_alpha = 0;
	else if(m_alpha > 255)
		m_alpha = 255;

	ConvertToOGLFloat();
}


// -------------------------------- END OF FILE -----------------------------------
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%








